#!/usr/bin/env python
# encoding: utf-8
"""
Author: Nick Bearson, nickb@ssec.wisc.edu
Copyright (c) 2012 University of Wisconsin SSEC. All rights reserved.
"""

# PYLONS VERSION DOESNT WORK - USING THIS ONE INSTEAD
# http://osdir.com/ml/sqlalchemy/2012-03/msg00232.html
class reify(object):
  """A read-only @property that is only evaluated once."""
  def __init__(self, fget, doc=None):
    self.fget = fget
    self.__doc__ = doc or fget.__doc__
    self.__name__ = fget.__name__

  def __get__(self, obj, cls):
    if obj is None:
      return self
    obj.__dict__[self.__name__] = result = self.fget(obj)
    return result